unit actors;

interface

uses types, obj;

type ACTORS_OBJECT = OBJECT (LIST_OBJECT)
       fussbudget: ACTOR;
       cage_bars: BAR_STATUS;
       procedure init_actors;
       procedure actors_proc;
       procedure actors_quit_proc;
       procedure cut_bars_proc;
       procedure wake_proc;
     end;

implementation

procedure ACTORS_OBJECT.init_actors;
begin
  fussbudget.awake := FALSE;
  fussbudget.room := cage;
  cage_bars := intact;
end;

procedure ACTORS_OBJECT.actors_proc;
begin

  if fussbudget.awake then
  begin

    if (current_room = sick_bay) and (cage_bars <> two_cut) then
    begin

      if phrase2 (open, cage) then
      begin
        spool_text ('"Open the Cage!" begs the Fussbudget, clawing at the bars. "I''m');
        spool_text ('claustrophobic! I''ll starve to death! I wanna go jogging!"');
      end
      else if phrase4 (unlock, cage, with_, key) and isHeld (key) then
      begin
        spool_text ('"Break the bars! Get an acetylene torch! Find a teleporter! I''ve got an');
        spool_text ('appointment with my lawyer in five minutes! I''m allergic to cages!"  The');
        spool_text ('Fussbudget begins sneezing wildly.');
      end
      else if phrase1 (north) then
      begin
        spool_text ('"It''s about time you got back. You think it''s fun being locked in a');
        spool_text ('cage? What if there was a fire?"');
      end;

    end; (* bars_intact *)

  end; (* fussbudget_awake *)

end; (* actors_proc *)

procedure ACTORS_OBJECT.actors_quit_proc;
begin

  if fussbudget.awake then
  begin
    spool_text ('The Fussbudget says, "Giving up Huh."');
    spool;
  end; (* if *)

end; (* actors_quit_proc *)

procedure ACTORS_OBJECT.cut_bars_proc;
begin

  if (cage_bars = intact) then
  begin
    if fussbudget.awake then
    begin
      spool_text ('You cut through one of the bars. The Fussbudget sticks its head through');
      spool_text ('the gap. "Come on, cut some more! I''m almost out...do you think these edges');
      spool_text ('where you cut the bars are sharp?"');
    end
    else
      spool_text ('You cut through one of the bars.');
    cage_bars := one_cut;
    list[cage].line[2] := 'One of the bars has been cut leaving a small gap.';
  end
  else if (cage_bars = one_cut) then
  begin
    if fussbudget.awake then
    begin
      spool_text ('You cut a second bar. The Fussbudget squeezes through and leaps to the floor.');
      spool_text ('"Thanks, bud. By the way, I''m a Fussbudget." It hops across the room and pokes');
      spool_text ('four or five eye stalks cautiously through the doorway. "Where is everyone?');
      if isHeld (paste) then
        spool_text ('Hey, that looks like a tube of nutrient paste you''ve got there."')
      else
        spool_text ('Hey, know where I can find some food?"');
    end
    else
      spool_text ('You cut a second bar.');
    cage_bars := two_cut;
    list[cage].line[2] := 'Two bars have been cut leaving a large gap.';
  end
  else
    spool_text ('The gap is big enough.')

end; (* cut_bars_proc *)

procedure ACTORS_OBJECT.wake_proc;
begin

  if (current_room = fussbudget.room)
  or ((current_room = sick_bay) and (fussbudget.room = cage)) then
  begin
    if fussbudget.awake then
      spool_text ('"Hey bud, stop poking me. I''m awake ain''t I."')
    else if (fussbudget.room = cage) then
    begin
      spool_text ('It jumps to its feet all twelve of them. "Hey, what''s going on? Who are you?');
      if (cage_bars = intact) then
        spool_text ('Lemme outta here!"')
      else if (cage_bars = one_cut) then
        spool_text ('Gee, a gap - but its not big enougth..."')
      else
      begin
        spool_text ('Gee, a gap". The Fussbudget squeezes through and leaps to the floor.');
        spool_text ('"Thanks, bud. By the way, I''m a Fussbudget." It hops across the room and pokes');
        spool_text ('four or five eye stalks cautiously through the doorway. "Where is everyone?');
        if isHeld (paste) then
          spool_text ('Hey, that looks like a tube of nutrient paste you''ve got there."')
        else
          spool_text ('Hey, know where I can find some food?"');
        fussbudget.room := sick_bay;
      end;
      fussbudget.awake := TRUE;
    end
    else
    begin
      spool_text ('The Fussbudget jumps up. "Solved the game yet bud?"');
      fussbudget.awake := TRUE;
    end; (* if *)
  end
  else
    spool_text ('The Fussbudget isn''t here!');

end; (* wake_proc *)

end.