unit global;

interface

uses types;

type GLOBAL_OBJECT = OBJECT
       current_room: VOCABULARY;
       room: array [first_room..last_room] of LOCATION;
       word: ARRAY [1..MAX_WORD] OF WORD_TYPE;
       function phrase1 (a                     : VOCABULARY):BOOLEAN;
       function phrase2 (a, b                  : VOCABULARY):BOOLEAN;
       function phrase3 (a, b, c               : VOCABULARY):BOOLEAN;
       function phrase4 (a, b, c, d            : VOCABULARY):BOOLEAN;
       function phrase6 (a, b, c, d, e, f      : VOCABULARY):BOOLEAN;
       function phrase8 (a, b, c, d, e, f, g, h: VOCABULARY):BOOLEAN;
     end;

implementation

function check_word (word_in1, word_in2: VOCABULARY):BOOLEAN;
begin
  check_word :=
  (word_in1 = word_in2) or
  (isObject        (word_in1) and (word_in2 = any_object)) or
  (isSpecialObject (word_in1) and (word_in2 = any_special_object)) or
  (isDirection     (word_in1) and (word_in2 = any_direction) or
  (word_in2 = any_word));
end;

function GLOBAL_OBJECT.phrase1 (a: VOCABULARY):BOOLEAN;
begin
  phrase1 := check_word (word[1].current, a) and (word[2].current=return)
end;

function GLOBAL_OBJECT.phrase2 (a, b: VOCABULARY):BOOLEAN;
begin
  phrase2 := check_word (word[1].current, a) and
             check_word (word[2].current, b) and (word[3].current=return)
end;

function GLOBAL_OBJECT.phrase3 (a, b, c: VOCABULARY):BOOLEAN;
begin
  phrase3 := check_word (word[1].current, a) and
             check_word (word[2].current, b) and
             check_word (word[3].current, c) and (word[4].current=return)
end;

function GLOBAL_OBJECT.phrase4 (a, b, c, d: VOCABULARY):BOOLEAN;
begin
  phrase4 := check_word (word[1].current, a) and
             check_word (word[2].current, b) and
             check_word (word[3].current, c) and
             check_word (word[4].current, d) and (word[5].current=return)
end;

function GLOBAL_OBJECT.phrase6 (a, b, c, d, e, f: VOCABULARY):BOOLEAN;
begin
  phrase6 := check_word (word[1].current, a) and
             check_word (word[2].current, b) and
             check_word (word[3].current, c) and
             check_word (word[4].current, d) and
             check_word (word[5].current, e) and
             check_word (word[6].current, f) and (word[7].current=return)
end;

function GLOBAL_OBJECT.phrase8 (a, b, c, d, e, f, g, h: VOCABULARY):BOOLEAN;
begin
  phrase8 := check_word (word[1].current, a) and
             check_word (word[2].current, b) and
             check_word (word[3].current, c) and
             check_word (word[4].current, d) and
             check_word (word[5].current, e) and
             check_word (word[6].current, f) and
             check_word (word[7].current, g) and
             check_word (word[8].current, h)
end;

end.
