unit obj_char;

interface

uses types, general, obj_lock;

type CHARACTERISTIC_OBJECT = OBJECT (LOCK_OBJECT)
       procedure eat_proc           (object_in: VOCABULARY);
       procedure cut_bars_with_proc (cutting_object: VOCABULARY);
       procedure cut_with_proc      (target, cutting_object: VOCABULARY);
     end;

implementation

procedure CHARACTERISTIC_OBJECT.eat_proc (object_in: VOCABULARY);
begin

  with list [object_in] do
  begin

    if characteristic  = edible then
    begin
      spool_text (eat_line[1]);
      spool_text (eat_line[2]);
      characteristic := eaten;
      name := 'empty '+name;
      hungry := well_fed;
    end
    else if characteristic  = eaten then
      spool_text ('That''s been eaten already!')
    else
      spool_text ('You can''t eat that!');

  end; (* with *)

end; (* eat_proc *)

procedure CHARACTERISTIC_OBJECT.cut_bars_with_proc (cutting_object: VOCABULARY);
begin

  if (current_room <> sick_bay) then
    spool_text ('You can''t see any bars here.')
  else if not isHeld (cutting_object) then
    spool_name ('You''re not holding the ',cutting_object,'.')
  else if (list[cutting_object].characteristic = cuts) then
    cut_bars_proc
  else
    spool_text ('That has no effect.');

end; (* cut_bars_with_proc *)

procedure CHARACTERISTIC_OBJECT.cut_with_proc (target, cutting_object: VOCABULARY);
begin

  if not isHeld (cutting_object) then
    spool_name ('You''re not holding the ',cutting_object,'.')
  else if not isHere (target) then
    spool_name ('The ',target,' isn''t here.')
  else if (target = cutting_object) then
    spool_text ('You can''t cut it with itself!')
  else
    spool_text ('That has no effect.');

end; (* cut_with_proc *)

end.