unit obj_wear;

interface

uses types, obj_take;

type WEAR_OBJECT = OBJECT (TAKE_OBJECT)
       procedure core_wear   (object_in: VOCABULARY);
       procedure wear_x_proc;
       procedure wear_proc   (object_in: VOCABULARY);
       procedure core_remove   (object_in: VOCABULARY);
       procedure remove_x_proc;
       procedure remove_proc   (object_in: VOCABULARY);
     end;

implementation

procedure WEAR_OBJECT.core_wear (object_in: VOCABULARY);
begin

  if isWearable (object_in) then
  begin
    list[object_in].place := wearing;
    spool_name ('You are now wearing the ',object_in,'.');
    advance_time (11);
    last_object := object_in; when := 1;
    if isWearing (watch) then is_wearing_watch := TRUE;
  end
  else
    spool_vowel ('You can''t wear ',object_in,'.');

end; (* core_wear *)

procedure WEAR_OBJECT.wear_x_proc;
var element, wear_object: VOCABULARY;
    objects_wearable: INTEGER;
begin

  objects_wearable := 0;

  for element := object_first to object_last do
    if isCarrying(element) and isWearable(element) then
    begin
      objects_wearable := objects_wearable + 1;
      if objects_wearable = 1 then
        wear_object := element;
    end;

  if objects_wearable = 0 then
    spool_text ('There''s nothing to wear!')
  else if objects_wearable = 1 then
  begin
    spool_name ('[the ',wear_object,']');
    core_wear (wear_object)
  end
  else
  begin
    spool_text ('[What do you want to wear?]');
    repeatCommand := wear;
  end;

end; (* wear_x_proc *)

procedure WEAR_OBJECT.wear_proc (object_in: VOCABULARY);
begin

  if isWearing (object_in) then
    spool_name ('You''re already wearing the ',object_in,'.')
  else if isHeld (object_in) then
    core_wear (object_in)
  else if isHere (object_in) then
    spool_name ('You''ll not holding the ',object_in,'.')
  else
    spool_text ('You can''t see that here!');

end; (* wear_proc *)

procedure WEAR_OBJECT.core_remove (object_in: VOCABULARY);
begin

  list[object_in].place := carrying;
  spool_name ('Okay, you''re no longer wearing the ',object_in,'.');
  advance_time (11);
  last_object := object_in; when := 1;
  if not isWearing (watch) then is_wearing_watch := FALSE;

end; (* core_remove *)

procedure WEAR_OBJECT.remove_x_proc;
begin

  if no_objects (wearing) then
    spool_text ('There''s nothing to remove!')
  else if one_object (wearing) then
  begin
    spool_name ('[the ',sole_object (wearing),']');
    core_remove (sole_object (wearing))
  end
  else
  begin
    spool_text ('[what do you want to remove?]');
    repeatCommand := remove;
  end;

end; (* remove_x_proc *)

procedure WEAR_OBJECT.remove_proc (object_in: VOCABULARY);
begin

  if isWearing (object_in) then
    core_remove (object_in)
  else
    spool_name ('You aren''t wearing the ',object_in,'.');

end; (* remove_proc *)

end.